/* ================= iTunes Emulation ======================== */

var RCiTunes = {
	volume : 1,
	platform : 'Remote',
	version : '-1',
	timecode : 0,
	// Need a more general watching mechanism, this will do for now
	timecodeWatcherCallback : null
};

RCiTunes.__defineGetter__("currentTime", function() {
	return this.timecode;
});
	
RCiTunes.__defineSetter__("currentTime", function(timecode) {
	this.timecode = timecode;
	RCSetCurrentTime(timecode);
});
	
RCiTunes.updateTimeCode = function(timecode) {
	var oldTimecode = this.timecode;
	
	this.timecode = timecode;
	
	// I don't fully understand the .call mechanism but this works for demo
	if (this.timecodeWatcherCallback)
	{
		this.timecodeWatcherCallback.call("currentTime", oldTimecode, timecode);
	}
};
	
RCiTunes.watch = function (prop, handler) {
	
	if (prop == "currentTime")
	{
		if (this.timecodeWatcherCallback)
		{
			alert('this.timecodeWatcherCallback was previously set!');
		}
		this.timecodeWatcherCallback = handler;
	}
	else
	{
		alert('RCiTunes.watch called with unsupported prop: ' + prop);
	}
};
	
RCiTunes.unwatch = function (prop) {
	if (prop == "currentTime")
	{
		this.timecodeWatcherCallback = null;
	}
};

RCiTunes.play = function (mediaLocation) {
	if (mediaLocation.startChapterIndex)
	{
		RCSetCurrentChapter(mediaLocation.startChapterIndex);
	}
	else if (mediaLocation == 0)
	{
		RCCommand("play");
	}
	RCLog("RCiTunes - play: " + mediaLocation);
};

RCiTunes.stop = function () {
	// Do we really want to stop? This was originally targeted for same device.
	// Not sure it makes sense in a second screen context
	RCLog("RCiTunes - stop");
};

RCiTunes.findTracksByStoreID = function (storeID) {
	RCLog("RCiTunes - findTracksByStoreID: " + storeID);
	return [new RCiTunesTrackEmulator()];
};

RCiTunes.findTracksByXID = function (xID) {
	RCLog("RCiTunes - findTracksByXID: " + xID);
	return [new RCiTunesTrackEmulator()];
};

RCiTunes.createTempPlaylist = function () {
	return {
    tracks: [],
    addTracks: function () {}
	};
};

function RCiTunesTrackEmulator() {
}

RCiTunesTrackEmulator.prototype.play = function (params) {
	RCLog("RCiTunesTrackEmulator - play: " + params);
	// fake the play event to the window
	var event = document.createEvent("HTMLEvents");
	event.initEvent("play", false, false);
	window.dispatchEvent(event);
	setTimeout(function() {
			   RCLog("RCiTunesTrackEmulator - coming back from playback");
			   event = document.createEvent("HTMLEvents");
			   event.initEvent("videoclosed", false, false);
			   window.dispatchEvent(event);
			   }, 5000);
};

