// MessageController to help synchronize our messages to Remote since window.open is an async
// mechanism
function RCMessageController() {
	this.queue = new Array();
	
	this.messagePending = false;
	
	this.checkQueue = function() {
		if (!this.messagePending && this.queue.length > 0)
		{
			// We have messages queued and no messages are currently sent to Remote so send one
			this.messagePending = true;
			var message = this.queue.shift();
			window.open(message, '_top');
		}
	};
	
	this.addMessage = function(message) {
		var mcMessage = 'mc:' + message;
		this.queue.push(mcMessage);
		this.checkQueue();
	};
};

// Global message controller
var mc = new RCMessageController();

function RCLog(msg)
{
	var message = 'log/' + msg;
	mc.addMessage(message);
}

function RCCommand(command)
{
	mc.addMessage(command);
}

function RCSetCurrentTime(timecode)
{
	var message = 'setCurrentTime/' + timecode;
	mc.addMessage(message);
}

function RCSetCurrentChapter(chapter)
{
	var message = 'setCurrentChapter/' + chapter;
	mc.addMessage(message);
}

function RCSwitchToLoadSpinner()
{
	RCCommand('loadingStarted');
}

function RCSwitchToContent()
{
	RCCommand('loadingComplete');
}

function RCSetTimeCode(timecode)
{
	window.iTunes.timecode = timecode;
}

// Function Callbacks for Remote to call into JS

function RCLoadRCiTunes()
{
	window.iTunes = RCiTunes;
}

function RCSetPlayState(state)
{
	window.iTunes.playState = state;
}

function RCiTunesLoaded()
{
	return (window.iTunes != null && window.iTunes != undefined && window.iTunes.platform == 'Remote')
}

function RCUpdateTimeCodeToValue(newTimecode)
{
	// Update the internal value instead of using the currentTime getter/setter.
	// We aren't trying to change the timecode, just make it reflect reality
	window.iTunes.updateTimeCode(newTimecode);
}

function RCMessageReceived()
{
	mc.messagePending = false;
	mc.checkQueue();
}

